# Program to calculate the molecular weight of a protein using the information stored 
# in a FASTA file
mw = 0

# Source for residue molecular weights: http://www.matrixscience.com/help/aa_help.html (Accessed # on May 8th 2014)
# To calculate the mass of a neutral peptide or protein, sum the residue masses plus the masses 
# of the terminating 
# groups (e.g. H at the N-terminus and OH at the C-terminus).
aaMW = {"A": 71.0779,"R": 156.1857,"N": 114.1026,"D": 115.0874,
        "C": 103.1429,"E": 129.114,"Q": 128.1292,"G": 57.0513,
        "H": 137.1393,"I": 113.1576,"L": 113.1576,"K": 128.1723,
        "M": 131.1961,"F": 147.1739,"P": 97.1152,"S": 87.0773,
        "T": 101.1039,"W": 186.2099,"Y": 163.1733,"V": 99.1311
        }

# Reads input file name
fastaIn = input("\nGive the input file name => ")
fh = open(fastaIn,'r')  # Opens input file
seqIn = fh.readlines()  # Reads all of the lines in a file and returns them as elements in a list
fh.close()              # Closes input file

# Removes the item at the given position in the list, and return it.
seqIn.pop(0)    # Removes first element of the list (get rid of the first line)

# Transforms list in string, so we will not get error with .replace()
seq=''.join(seqIn)

# Removes all "/n" from the string seq
seq = seq.replace("\n","")

# Loop for to add the amino acid molecular weight
for aa in seq:
    mw += float(aaMW[aa])

mw = mw + 18.0148 # Sums water molecule

# Shows result
print("\nThe protein weighs %8.3f"%mw," Daltons")
